﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using com.jnbridge.jnbproxy;
using com.jnbridge.labs.visio;
using org.apache.hadoop.hdfs.protocol;
using org.apache.hadoop.hdfs.server.namenode;
using org.apache.hadoop.mapred;
using org.apache.hadoop.net;

// VisualizerMain.cs
// Main class that runs the visualizer. Also sets up connection to Java side

namespace HadoopVisProto
{
    class VisualizerMain
    {
        public static bool closedFlag = false;

        static void Main(string[] args)
        {
            try
            {
                // Connect to the two Java sides
                // The jobTracker side is automatically named "default" 
                JNBRemotingConfiguration.specifyRemotingConfiguration(JavaScheme.binary, "obiwan.local", 8085);
                // We name the nameNode side "NameNode" 
                JavaSides.addJavaServer("NameNode", JavaScheme.binary, "obiwan.local", 8087);

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

            try
            {
                JobTracker jobtracker = JnbpJobTrackerWrapper.getJobTracker();
                java.util.Collection temp = jobtracker.activeTaskTrackers();
                java.lang.Object[] tts = temp.toArray();
                JavaSides.setJavaServer("NameNode");
                NameNode namenode = JnbpNameNodeWrapper.getNameNode();
                HadoopTree.buildTree(jobtracker, "obiwan.local", "obiwan.local", tts, namenode.getDatanodeReport(FSConstants.DatanodeReportType.ALL));
                while (!closedFlag)
                {
                    JavaSides.setJavaServer("NameNode");
                    DatanodeInfo[] dnReport = namenode.getDatanodeReport(FSConstants.DatanodeReportType.ALL);
                    JavaSides.setJavaServer("default");
                    HadoopTree.updateTree(jobtracker.activeTaskTrackers().toArray(), jobtracker.blacklistedTaskTrackers().toArray(), dnReport);
                    System.Threading.Thread.Sleep(3000);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }
    }
}
